## ros-noetic-openzen-sensor 1.3.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(openzen_sensor)

set(CMAKE_CXX_FLAGS "-std=c++11")

find_package(catkin REQUIRED COMPONENTS
  roscpp
  sensor_msgs 
)

option(OPENZEN_ROS_BINARY_DOWNLOAD "Download binary builds" OFF)
option(OPENZEN_ROS_BINARY_LIBRARIES "Download binary dependencies" OFF)

# check if we can build OpenZen or if we need to download
# a binary version
set(BUILD_OPENZEN ON)
if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
  message(WARNING "At least GCC version 7.0 needed to build OpenZen, will download binary version")
  set(BUILD_OPENZEN OFF)
endif()

if(${CMAKE_VERSION} VERSION_LESS "3.10.0")
  message(WARNING "At least cmake version 3.10 needed to build OpenZen, will download binary version")
  set(BUILD_OPENZEN OFF)
endif()

if (NOT BUILD_OPENZEN AND NOT OPENZEN_ROS_BINARY_DOWNLOAD)
  message(FATAL_ERROR "Dependencies to build OpenZen not met and binary download disabled.")
endif()

if (BUILD_OPENZEN)
  SET(ZEN_BLUETOOTH OFF CACHE BOOL "Don't build bluetooth")
  SET(ZEN_TESTS OFF CACHE BOOL "Don't build tests")
  SET(ZEN_EXAMPLES OFF CACHE BOOL "Don't build examples")
  SET(ZEN_USE_BINARY_LIBRARIES ${OPENZEN_ROS_BINARY_LIBRARIES} CACHE BOOL "Don't download binary dependencies (windows only)")
  add_subdirectory(openzen)
  SET(OPENZEN_TARGET_NAME OpenZen)
else()
  set(OPENZEN_BINARY_FOLDER "${CMAKE_CURRENT_BINARY_DIR}/OpenZenBinary")
  set(OPENZEN_ARCHIVE_FILE "${CMAKE_CURRENT_BINARY_DIR}/OpenZenRelease.tar.gz")
  set(OPENZEN_BASE_FOLDER "${CMAKE_CURRENT_BINARY_DIR}/openzen_release")

  if (CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "x86_64")
    set(OPENZEN_DOWNLOAD_URL "https://bitbucket.org/lpresearch/openzen/downloads/OpenZen-Ubuntu1604-x64-1.2.0.tar.gz")
    set(OPENZEN_DOWNLOAD_HASH 8a9f0ffa03fc1bd49fb41248a9c08c63e0f427086c579a2725105b0e0e0b768b)
  elseif((CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "arm64") OR (CMAKE_HOST_SYSTEM_PROCESSOR STREQUAL "aarch64"))
    set(OPENZEN_DOWNLOAD_URL "https://bitbucket.org/lpresearch/openzen/downloads/OpenZen-Ubuntu1604-arm64-1.2.0.tar.gz")
    set(OPENZEN_DOWNLOAD_HASH 385f6751035dfba475efda8e90680921330b0c556ad6b8204ed626fd9ead4359)
  else()
    message(FATAL_ERROR "No binary OpenZen release available for platform ${CMAKE_HOST_SYSTEM_PROCESSOR}")
  endif()

  if(NOT EXISTS ${OPENZEN_BINARY_FOLDER})
    if(NOT EXISTS ${OPENZEN_ARCHIVE_FILE})
          message("Will unpack to ${OPENZEN_ARCHIVE_FILE}")
      message(STATUS "Downloading OpenZen release from ${OPENZEN_DOWNLOAD_URL}")
      file(DOWNLOAD ${OPENZEN_DOWNLOAD_URL} ${OPENZEN_ARCHIVE_FILE}
            SHOW_PROGRESS
            EXPECTED_HASH SHA256=${OPENZEN_DOWNLOAD_HASH})
    endif()

    # unpack
    execute_process(COMMAND ${CMAKE_COMMAND} -E tar -xf ${OPENZEN_ARCHIVE_FILE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR})
  endif()

  find_package(OpenZen REQUIRED PATHS ${OPENZEN_BASE_FOLDER})
  SET(OPENZEN_TARGET_NAME OpenZen::OpenZen)
endif()

## Declare a catkin package
catkin_package()

## Build 
include_directories(include ${catkin_INCLUDE_DIRS})

add_executable(openzen_sensor_node
  src/OpenZenNode.cpp
)

target_link_libraries(openzen_sensor_node
  ${catkin_LIBRARIES}
  ${OPENZEN_TARGET_NAME}
)

add_dependencies(openzen_sensor_node ${catkin_EXPORTED_TARGETS})

## install node binary
install(TARGETS openzen_sensor_node
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

if (CATKIN_ENABLE_TESTING)
  find_package(rostest REQUIRED)
  add_rostest(launch/openzen_test.launch)
endif()

=== openzen/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

if (APPLE)
# enable_language(OBJCXX) misidentifies .mm files as C++ when doing a Unity build,
# so we have to use this if().
project(OpenZen VERSION 1.0.0 LANGUAGES C;CXX;OBJCXX)
else()
project(OpenZen VERSION 1.0.0 LANGUAGES C;CXX)
endif()

option(ZEN_MSVC_RUNTIME_STATIC "Link the MSVC runtime statically, useful for library releases" OFF)

# Global compile options which also affect the externals
if (MSVC)
    # make sure we link with the static runtime libraries
    # and have no dependencies on VC++ studio DLLs during runtime
    # We don't have any C++ exposed, so the C++ compatibility
    # to the host program of the DLL is not required

    # according to
    # https://gitlab.kitware.com/cmake/community/-/wikis/FAQ#how-can-i-build-my-msvc-application-with-a-static-runtime
    if (ZEN_MSVC_RUNTIME_STATIC)
        foreach(flag_var
                CMAKE_CXX_FLAGS CMAKE_CXX_FLAGS_DEBUG CMAKE_CXX_FLAGS_RELEASE
                CMAKE_CXX_FLAGS_MINSIZEREL CMAKE_CXX_FLAGS_RELWITHDEBINFO)
           if(${flag_var} MATCHES "/MD")
              string(REGEX REPLACE "/MD" "/MT" ${flag_var} "${${flag_var}}")
           endif(${flag_var} MATCHES "/MD")
        endforeach(flag_var)
    endif()

    # select windows 7 as base version
    # https://docs.microsoft.com/en-us/cpp/porting/modifying-winver-and-win32-winnt?view=vs-2019
    add_definitions(-D_WIN32_WINNT=0x0601)
    add_definitions(-D_WINVER=0x0601)
endif()

if (CMAKE_COMPILER_IS_GNUCC AND CMAKE_CXX_COMPILER_VERSION VERSION_LESS 7.0)
    message(FATAL_ERROR "GCC Version 7.0 or newer is needed to compile OpenZen")
endif()

set (ZEN_BLUETOOTH_DEFAULT ON)

## check if libbluetooth is available on non-Apple Unix
if(UNIX AND NOT APPLE)
    find_library(LIBBLUETOOTH_LIBRARY
        NAMES bluetooth)

    if (NOT LIBBLUETOOTH_LIBRARY)
        set(ZEN_BLUETOOTH_DEFAULT OFF)

        message("Please install libbluetooth-dev for bluetooth support")
        if (ZEN_BLUETOOTH)
            # give a fatal error message if Bluetooth support was requested
            # by cmake parameters but we cannot fullfil it
            message(FATAL_ERROR "libbluetooth-dev required to compile with Bluetooth support")
        endif()
    endif()
endif()

# Please note: The static OpenZen build does not support library installation (aka "make install")
# as the private dependencies cannot be resolved by CMake
# see https://gitlab.kitware.com/cmake/cmake/issues/17357 for example
option(ZEN_USE_STATIC_LIBS "Whether to compile OpenZen as a static library" OFF)
option(ZEN_STATIC_LINK_LIBCXX "Option to statically link libstdc++ to be portable to older systems (Linux only)" OFF)
# linux needs libbluetooth-dev to be able to compile, so disable it by default
option(ZEN_BLUETOOTH "Compile OpenZen with bluetooth support" ${ZEN_BLUETOOTH_DEFAULT})
option(ZEN_PCAN "Compile OpenZen Peak CAN USB adapter support" OFF)
option(ZEN_BLUETOOTH_BLE "Compile OpenZen with bluetooth low-energy support, needs Qt installed" OFF)
option(ZEN_NETWORK "Compile OpenZen with support for network streaming of measurement data" OFF)
option(ZEN_CSHARP "Compile C# bindings for OpenZen" ON)
option(ZEN_PYTHON "Compile Python bindings for OpenZen" OFF)
option(ZEN_TESTS "Compile with OpenZen tests" ON)
option(ZEN_EXAMPLES "Compile with OpenZen examples" ON)
option(ZEN_USE_BINARY_LIBRARIES "If set to true, binaries libraries are downloaded during the build" ON)

# Enable this line and set it to the correct Qt installation path if you want to compile
# with bluetooth support on Windows
#set(CMAKE_PREFIX_PATH "C://Qt//5.12.3//msvc2017_64//")

#----------------------------------------------------------------
# Packages
#----------------------------------------------------------------
# Find includes in corresponding build include_directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)

add_subdirectory(external)

# contains additional C/C++ precompiler defines
# which might be set depending on the selected compile options
set(zen_optional_compile_definitions_private)
set(zen_optional_compile_options)
set(zen_optional_libs)

# set the correct log level
if (CMAKE_BUILD_TYPE STREQUAL "Debug")
    # this will enable the SPDLOG_DEBUG macros for the build
    list (APPEND zen_optional_compile_definitions_private
        SPDLOG_ACTIVE_LEVEL=1
    )
endif()

if (ZEN_BLUETOOTH_BLE)
    # Instruct CMake to run moc automatically when needed
    set(CMAKE_AUTOMOC ON)
    find_package(Qt5Bluetooth REQUIRED)
endif()

set(zen_includes
    include/OpenZen.h
    include/OpenZenCAPI.h
    include/ZenTypes.h
)

set(zen_sources
    src/InternalTypes.h
    src/ISensorProperties.cpp
    src/ISensorProperties.h
    src/OpenZen.cpp
    src/Sensor.cpp
    src/Sensor.h
    src/SensorClient.cpp
    src/SensorClient.h
    src/SensorConfig.h
    src/SensorComponent.h
    src/SensorManager.cpp
    src/SensorManager.h
    src/SensorProperties.cpp
    src/SensorProperties.h

    src/LpMatrix.cpp
    src/LpMatrix.h
)

# source files which only get compiled into the
# library and not into the unit tests
set(zen_library_only_sources)

if(ZEN_PYTHON)
    list (APPEND zen_library_only_sources
        src/bindings/OpenZenPython.cpp
    )
    list (APPEND zen_optional_libs pybind11)
    # select C++17 if we do a Python build because the C++17 interface of OpenZen.h
    # is more convenient than the C++11 version
    list (APPEND zen_optional_compile_definitions_private
        OPENZEN_CXX17
    )
endif()

if(ZEN_CSHARP)
    if(CMAKE_SIZEOF_VOID_P EQUAL 8) # 64-bit
        set(SWIG_FLAGS "-DSWIGWORDSIZE64")
    else() # 32-bit
        set(SWIG_FLAGS "-DSWIGWORDSIZE32")
    endif()

    list (APPEND zen_sources
        ## run
        # swig -csharp -small -c++ -debug-typedef -DSWIGWORDSIZE64 -o OpenZenCSharp/OpenZen_wrap_csharp.cxx -outdir OpenZenCSharp OpenZen.i
        # in the bindings folder to generate
        bindings/OpenZenCSharp/OpenZen_wrap_csharp.cxx
    )
endif()

set(zen_optional_test_sources)

set(processors_sources
    src/processors/DataProcessor.h
)

set(communication_sources
    src/communication/ConnectionNegotiator.cpp
    src/communication/ConnectionNegotiator.h
    src/communication/Modbus.cpp
    src/communication/Modbus.h
    src/communication/ModbusCommunicator.cpp
    src/communication/ModbusCommunicator.h
    src/communication/SyncedModbusCommunicator.cpp
    src/communication/SyncedModbusCommunicator.h
)

set(components_sources
    src/components/ComponentFactoryManager.cpp
    src/components/ComponentFactoryManager.h
    src/components/IComponentFactory.h
    src/components/ImuComponent.cpp
    src/components/ImuComponent.h
    src/components/ImuIg1Component.cpp
    src/components/ImuIg1Component.h
    src/components/GnssComponent.cpp
    src/components/GnssComponent.h
    src/components/SensorParsingUtil.h
)

set(components_factories_sources
    src/components/factories/ImuComponentFactory.cpp
    src/components/factories/ImuComponentFactory.h
    src/components/factories/GnssComponentFactory.cpp
    src/components/factories/GnssComponentFactory.h
)

set(io_sources
    src/io/IIoInterface.h
    src/io/IIoSystem.h
    src/io/IoManager.cpp
    src/io/IoManager.h
)

set(io_interfaces_sources
    src/io/interfaces/TestSensorInterface.cpp
    src/io/interfaces/TestSensorInterface.h
)

set(io_systems_sources
    src/io/systems/TestSensorSystem.cpp
    src/io/systems/TestSensorSystem.h
)

set(properties_sources
    src/properties/BaseSensorPropertiesV0.h
    src/properties/BaseSensorPropertiesV1.h
    src/properties/CorePropertyRulesV1.h
    src/properties/ImuPropertyRulesV1.h
    src/properties/ImuPropertyRulesV2.h
    src/properties/ImuSensorPropertiesV0.h
    src/properties/ImuSensorPropertiesV1.h
    src/properties/LegacyCoreProperties.cpp
    src/properties/LegacyCoreProperties.h
    src/properties/Ig1CoreProperties.cpp
    src/properties/Ig1CoreProperties.h
    src/properties/LegacyImuProperties.cpp
    src/properties/LegacyImuProperties.h
    src/properties/Ig1ImuProperties.cpp
    src/properties/Ig1ImuProperties.h
    src/properties/Ig1GnssProperties.cpp
    src/properties/Ig1GnssProperties.h
)

set(utility_sources
    src/utility/Finally.h
    src/utility/IPlatformDll.h
    src/utility/LockingQueue.h
    src/utility/Ownership.h
    src/utility/ReferenceCmp.h
    src/utility/StringView.h
    src/utility/ThreadFence.h
    src/utility/gnss/RTCM3NetworkSource.h
    src/utility/gnss/RTCM3NetworkSource.cpp
    src/utility/gnss/RTCM3SerialSource.h
    src/utility/gnss/RTCM3SerialSource.cpp
    src/utility/gnss/RTCM3Parser.h
)

if(ZEN_PCAN)
    set(io_can_sources
        src/io/can/CanManager.cpp
        src/io/can/CanManager.h
        src/io/can/ICanChannel.h
    )

    set(io_interfaces_sources
        src/io/interfaces/CanInterface.cpp
        src/io/interfaces/CanInterface.h
    )
endif()

if(ZEN_BLUETOOTH_BLE)
    set(io_ble_sources
        src/io/ble/BleDeviceFinder.cpp
        src/io/ble/BleDeviceFinder.h
        src/io/ble/BleDeviceHandler.cpp
        src/io/ble/BleDeviceHandler.h
    )

    list (APPEND io_systems_sources
        src/io/systems/BleSystem.cpp
        src/io/systems/BleSystem.h
    )

    list (APPEND io_interfaces_sources
        src/io/interfaces/BleInterface.cpp
        src/io/interfaces/BleInterface.h
    )

    list (APPEND zen_optional_libs
        Qt5::Bluetooth
    )

    list (APPEND zen_optional_compile_definitions_private
        ZEN_BLUETOOTH_BLE
    )
endif()

if(ZEN_BLUETOOTH)
    set(io_bluetooth_sources
        src/utility/bluetooth-serial-port/BluetoothException.h
        src/utility/bluetooth-serial-port/BTSerialPortBinding.h
        src/utility/bluetooth-serial-port/DeviceINQ.h
        src/utility/bluetooth-serial-port/Enums.h
        src/utility/bluetooth-serial-port/Enums.cc
        src/io/bluetooth/BluetoothDeviceFinder.cpp
        src/io/bluetooth/BluetoothDeviceFinder.h
        src/io/bluetooth/BluetoothDeviceHandler.cpp
        src/io/bluetooth/BluetoothDeviceHandler.h
    )

    if(WIN32) # windows
        list (APPEND io_bluetooth_sources
            src/utility/bluetooth-serial-port/windows/BluetoothHelpers.cc
            src/utility/bluetooth-serial-port/windows/BTSerialPortBinding.cc
            src/utility/bluetooth-serial-port/windows/DeviceINQ.cc
        )

        list (APPEND zen_optional_libs
            ws2_32
            bthprops
        )
    elseif(APPLE) # MacOSX
        list (APPEND io_bluetooth_sources
            src/utility/bluetooth-serial-port/osx/BluetoothDeviceResources.mm
            src/utility/bluetooth-serial-port/osx/BluetoothWorker.mm
            src/utility/bluetooth-serial-port/osx/BTSerialPortBinding.mm
            src/utility/bluetooth-serial-port/osx/DeviceINQ.mm
            src/utility/bluetooth-serial-port/osx/pipe.c
        )
        find_library(FOUNDATION Foundation)
        find_library(IOBLUETOOTH IOBluetooth)
        list (APPEND zen_optional_libs
            ${FOUNDATION}
            ${IOBLUETOOTH}
            -fobjc-arc
        )

        add_executable(btScan src/utility/bluetooth-serial-port/osx/btScan.mm)
        target_link_libraries(btScan ${FOUNDATION} ${IOBLUETOOTH})
        # Use a non-ancient C++ version for compilation ...
        target_compile_features(btScan PRIVATE cxx_variadic_templates)
    else() # Linux
        list (APPEND io_bluetooth_sources
            src/utility/bluetooth-serial-port/linux/BTSerialPortBinding.cc
            src/utility/bluetooth-serial-port/linux/DeviceINQ.cc
        )

        list (APPEND zen_optional_libs
            bluetooth
        )
    endif()

    list (APPEND io_systems_sources
        src/io/systems/BluetoothSystem.cpp
        src/io/systems/BluetoothSystem.h
    )

    list (APPEND io_interfaces_sources
        src/io/interfaces/BluetoothInterface.cpp
        src/io/interfaces/BluetoothInterface.h
    )

    list (APPEND zen_optional_compile_definitions_private
        ZEN_BLUETOOTH
    )
endif()

if(ZEN_NETWORK)
    set(io_zeromq_sources

=== openzen/examples/CMakeLists.txt ===
set(example_sources
    main.cpp
)

add_executable(OpenZenExample
    ${example_sources}
)

include(FindThreads)

target_compile_features(OpenZenExample
    PRIVATE
        cxx_std_14
)

target_link_libraries(OpenZenExample
    PRIVATE
        OpenZen
        GSL
        Threads::Threads
        spdlog
)

if(ZEN_USE_STATIC_LIBS)
    target_compile_definitions(OpenZenExample
        PRIVATE
            ZEN_API_STATIC
    )
else()
    add_custom_command(TARGET OpenZenExample POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            $<TARGET_FILE:OpenZen>
            $<TARGET_FILE_DIR:OpenZenExample>
    )
endif()

# only copy Qt libraries if Bluetooth BLE support is enabled
if(ZEN_BLUETOOTH_BLE)
    add_custom_command(TARGET OpenZenExample POST_BUILD
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
            $<TARGET_FILE:Qt5::Bluetooth>
            $<TARGET_FILE_DIR:OpenZenExample>
        COMMAND ${CMAKE_COMMAND} -E copy_if_different
           $<TARGET_FILE:Qt5::Core>
            $<TARGET_FILE_DIR:OpenZenExample>
    )
endif()

if (MSVC)
    target_compile_options(OpenZenExample
        PRIVATE
            /Zc:__cplusplus
    )
endif()

# Disabled for now, as it results on compiler errors with Visual Studio static
# runtime linking
if (!MSVC)
    add_executable(OpenZenExampleCAPI
        ExampleCAPI.c)

    target_link_libraries(OpenZenExampleCAPI
        OpenZen)
endif()

add_executable(OpenZenExampleCpp
    ExampleCpp.cpp)

target_link_libraries(OpenZenExampleCpp
    OpenZen)

target_compile_features(OpenZenExampleCpp
    PRIVATE
        cxx_std_11
)

add_executable(OpenZenExampleCpp17
    ExampleCpp17.cpp)

target_link_libraries(OpenZenExampleCpp17
    OpenZen)

target_compile_features(OpenZenExampleCpp17
    PRIVATE
        cxx_std_17
)

=== openzen/external/CMakeLists.txt ===
# EXCLUDE_FROM_ALL is needed for the header-only libraries
# so their headers and cmake files are not copied to the
# output folder when "make install" is used

if (ZEN_USE_STATIC_LIBS)
    # install spdlog in case of static build
    # because CMake will otherwise complain about
    # missing export target
    set(SPDLOG_INSTALL ON CACHE BOOL "" FORCE)
    set(PYBIND11_INSTALL ON CACHE BOOL "" FORCE)
endif()

add_subdirectory(expected-lite EXCLUDE_FROM_ALL)
add_subdirectory(gsl EXCLUDE_FROM_ALL)

if (ZEN_TESTS)
    set(gtest_force_shared_crt ON CACHE BOOL "" FORCE)
    add_subdirectory(googletest EXCLUDE_FROM_ALL)
endif()

# download binary driver libraries for windows if
# we compile for Win32 and we are allowed by the build
# options todo so
if (WIN32 AND ZEN_USE_BINARY_LIBRARIES)
    message("Binary libraries will be downloaded")

    # FetchContent is supported since CMake Version 3.11
    include(FetchContent)
    set(FETCHCONTENT_QUIET OFF)
    FetchContent_Declare(
        binary_libraries
        GIT_REPOSITORY https://bitbucket.org/lpresearch/openzenbinarylibraries.git
        GIT_TAG        v1.0.0
    )

    FetchContent_GetProperties(binary_libraries)

    if (NOT binary_libraries_POPULATED)
      FetchContent_Populate(binary_libraries)
      add_subdirectory(${binary_libraries_SOURCE_DIR} ${binary_libraries_BINARY_DIR})
    endif()
else()
    message("Binary libraries will not be downloaded")
endif()

if (ZEN_PYTHON)
    find_package (Python3 REQUIRED COMPONENTS Development Interpreter)
    add_library(pybind11 INTERFACE)
    target_include_directories(pybind11 INTERFACE ./pybind11/include)
    target_link_libraries(pybind11 INTERFACE Python3::Python)
endif()

# tells cereal to not build any tests
set(JUST_INSTALL_CEREAL ON CACHE BOOL "" FORCE)
# we don't want cereals install targets, so use
# EXCLUDE_FROM_ALL on this folder

# currently, the cereal external gives an cmake warning
# because project() call does not set version. There is a PR in the pipeline
# which will fix this in the future
# https://github.com/USCiLab/cereal/pull/659
add_subdirectory(cereal EXCLUDE_FROM_ALL)

add_subdirectory(spdlog EXCLUDE_FROM_ALL)
set_property(TARGET spdlog PROPERTY POSITION_INDEPENDENT_CODE ON)

# expose the Asio headers as library
add_library(openzen_asio INTERFACE)
target_include_directories(openzen_asio INTERFACE
    ${CMAKE_CURRENT_SOURCE_DIR}/asio/asio/include
    )

if (ZEN_NETWORK)
    set(ENABLE_PRECOMPILED OFF CACHE BOOL "" FORCE)
    set(BUILD_TESTS OFF CACHE BOOL "" FORCE)
    set(WITH_PERF_TOOL OFF CACHE BOOL "" FORCE)
    set(BUILD_STATIC ON CACHE BOOL "" FORCE)
    set(BUILD_SHARED OFF CACHE BOOL "" FORCE)
    set(ZMQ_BUILD_TESTS OFF CACHE BOOL "" FORCE)
    add_subdirectory(libzmq)

    # expose the cppzmq header as library because the cmake file coming
    # with the library uses CMake's find to look up the system-installed
    # zero mq
    add_library(cppzmq INTERFACE)
    target_include_directories(cppzmq INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/cppzmq>
        $<INSTALL_INTERFACE:include/cppzmq>
        )
endif()

=== openzen/external/cereal/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6...3.15)

project(cereal LANGUAGES CXX VERSION 1.3.0)

if(PROJECT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
    set(CEREAL_MASTER_PROJECT ON)
endif()


if(APPLE)
    option(SKIP_PORTABILITY_TEST "Skip portability (32 bit) tests" ON)
endif()

option(SKIP_PERFORMANCE_COMPARISON "Skip building performance comparison (requires boost)" OFF)

# TODO: should not be needed! CK
if(NOT CMAKE_VERSION VERSION_LESS 3.0) # installing cereal requires INTERFACE lib
    option(JUST_INSTALL_CEREAL "Don't do anything besides installing the library" OFF)
endif()


set(CEREAL_THREAD_LIBS)
if(UNIX)
    option(THREAD_SAFE "Use mutexes to ensure thread safety" OFF)
    if(THREAD_SAFE)
        message(STATUS "Use mutexes")
        add_definitions(-DCEREAL_THREAD_SAFE=1)
        set(CEREAL_THREAD_LIBS pthread)
    endif()
endif()


if(MSVC)
    add_compile_options(/bigobj /W3 /WX)
else()
    add_compile_options(-Wall -Wextra -pedantic -Wshadow -Wold-style-cast)
    option(WITH_WERROR "Compile with '-Werror' C++ compiler flag" ON)
    if(WITH_WERROR)
        add_compile_options(-Werror)
    endif()

    option(CLANG_USE_LIBCPP "Use libc++ for clang compilation" OFF)
    if(APPLE OR CLANG_USE_LIBCPP)
        message(STATUS "Use libc++")
        add_compile_options(-stdlib=libc++)
        # TODO: use add_link_options(-stdlib=libc++ -lc++abi") bud this needs cmake 3.13! CK
        set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -stdlib=libc++ -lc++abi")
    endif()

    if(NOT DEFINED CMAKE_CXX_STANDARD OR CMAKE_CXX_STANDARD STREQUAL "98")
        set(CMAKE_CXX_STANDARD 11)
    endif()

    set(CMAKE_CXX_STANDARD_REQUIRED ON)
endif()


add_library(cereal INTERFACE)
add_library(cereal::cereal ALIAS cereal)
target_include_directories(cereal INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>
)
list(APPEND CEREAL_THREAD_LIBS cereal::cereal)

if(NOT CMAKE_VERSION VERSION_LESS 3.8)
    target_compile_features(cereal INTERFACE cxx_std_11)
endif()


option(CEREAL_INSTALL "Generate the install target" ${CEREAL_MASTER_PROJECT})
if(CEREAL_INSTALL)
    include(CMakePackageConfigHelpers)

    install(TARGETS cereal EXPORT ${PROJECT_NAME}Targets)
    install(DIRECTORY include/cereal DESTINATION include)

    set(configFile ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}Config.cmake)
    set(versionFile ${CMAKE_CURRENT_BINARY_DIR}/${PROJECT_NAME}ConfigVersion.cmake)
    set(configInstallDestination lib/cmake/${PROJECT_NAME})

    configure_package_config_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/Config.cmake.in
        ${configFile}
        INSTALL_DESTINATION ${configInstallDestination}
    )
    write_basic_package_version_file(
        ${versionFile}
        COMPATIBILITY SameMajorVersion
    )

    install(FILES ${configFile} ${versionFile} DESTINATION ${configInstallDestination})
    install(
        EXPORT ${PROJECT_NAME}Targets
        NAMESPACE "cereal::"
        DESTINATION ${configInstallDestination}
    )
endif()


if(JUST_INSTALL_CEREAL)
    return()
endif()


if(NOT SKIP_PERFORMANCE_COMPARISON)
    # Boost serialization for performance sandbox
    find_package(Boost REQUIRED COMPONENTS serialization)
endif()


option(BUILD_TESTS "Build tests" ${CEREAL_MASTER_PROJECT})
if(BUILD_TESTS)
    enable_testing()
    add_subdirectory(unittests)
endif()

add_subdirectory(sandbox)

add_subdirectory(doc)

=== openzen/external/cppzmq/tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0 FATAL_ERROR)

project(cppzmq-test CXX)

# place binaries and libraries according to GNU standards

include(GNUInstallDirs)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_LIBDIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR})

include(CTest)
include(cmake/catch.cmake)
include(${CATCH_MODULE_PATH}/Catch.cmake)

find_package(Threads)

add_executable(
    unit_tests
    buffer.cpp
    message.cpp
    context.cpp
    socket.cpp
    socket_ref.cpp
    poller.cpp
    active_poller.cpp
    multipart.cpp
    recv_multipart.cpp
    send_multipart.cpp
    monitor.cpp
    utilities.cpp
)

add_dependencies(unit_tests catch)

target_include_directories(unit_tests PUBLIC ${CATCH_MODULE_PATH})
target_link_libraries(
    unit_tests
    PRIVATE cppzmq
    PRIVATE ${CMAKE_THREAD_LIBS_INIT}
)

OPTION (COVERAGE "Enable gcda file generation needed by lcov" OFF)

if (COVERAGE)
    target_compile_options(unit_tests PRIVATE --coverage)
    target_link_libraries(unit_tests PRIVATE --coverage)
endif()

catch_discover_tests(unit_tests)

=== debian/changelog ===
ros-noetic-openzen-sensor (1.3.2-1focal) focal; urgency=high

  * fix default gyro mapping for legacy sensor
    tested with URS2
  * update ros package version to v1.3.1
  * update submodule openzen to v1.3.1 to support LPMS3 sensors
  * switch default gyros for different sensors
  * updated OpenZen to be able to parse 16-bit data format messages for IG1
  * updated to recent OpenZen to be able to directly connect to Linux device files
  * added link to melodic ROS directly
  * Contributors: LP-Research Inc. Team

 -- H.E. YAP <yap@lp-research.com>  Mon, 28 Aug 2023 15:00:00 -0000

ros-noetic-openzen-sensor (1.2.0-1focal) focal; urgency=high

  * fixed conditions check for build or download OpenZen options
  * fixed name of primary maintainer
  * added install target for openzen_node
  * manually setting component ID in case a TestSensor is used
  * running rostest as part of the catkin CMake file
  * switched binary downloads to OpenZen 1.2.0
  * updated OpenZen to version 1.2.0
  * added output of GNSS measurement as ROS NavSatFix message
  * Contributors: LP-Research Inc. Team

 -- Thomas Hauth <thomas@lp-research.com>  Mon, 16 Nov 2020 15:00:00 -0000

ros-noetic-openzen-sensor (1.0.1-1focal) focal; urgency=high

  * changed OpenZen version to release 1.1.3
  * added option to select binary download and disabled binary downloads by default
  * updated to OpenZen 1.1.2 for ARM64
  * updated OpenZen version to support LPMS-BE1
  * added support for ARM64 binary
  * checking if environment is modern enough to build OpenZen, otherwise download binary release
  * added licenses of OpenZen and its dependencies
  * added License header to source files
  * added License file
  * Contributors: LP-Research Inc. Team

 -- Thomas Hauth <thomas@lp-research.com>  Wed, 02 Sep 2020 15:00:00 -0000

ros-noetic-openzen-sensor (1.0.0-1focal) focal; urgency=high

  * Initial Release of OpenZen ROS driver
  * Contributors: LP-Research Inc. Team

 -- Thomas Hauth <thomas@lp-research.com>  Sun, 12 Apr 2020 15:00:00 -0000

=== debian/control ===
Source: ros-noetic-openzen-sensor
Section: misc
Priority: optional
Maintainer: H.E. YAP <yap@lp-research.com>
Build-Depends: debhelper (>= 9.0.0), ros-noetic-catkin, ros-noetic-roscpp, ros-noetic-roslaunch <!nocheck>, ros-noetic-rostest <!nocheck>, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs
Homepage: 
Standards-Version: 3.9.2

Package: ros-noetic-openzen-sensor
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-noetic-roscpp, ros-noetic-sensor-msgs, ros-noetic-std-msgs, ros-noetic-std-srvs, ros-noetic-tf, ros-noetic-topic-tools
Description: ROS driver for LP-Research inertial measurement units and satellite navigation senors

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/noetic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF -DCATKIN_ENABLE_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/noetic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/noetic" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-noetic-openzen-sensor//opt/ros/noetic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/noetic/setup.sh" ]; then . "/opt/ros/noetic/setup.sh"; fi && \
	dh_auto_install
